using System;
using System.Collections;
using Heap;

class Foo 
{ 
    private Foo foo;

    internal Foo(int level) 
    { 
        if (--level >= 0) 
        { 
            foo = new Foo(level);
        }
    }
}

public class HeapWalk 
{
    internal ArrayList list;

    HeapWalk()  
    { 
        list = new ArrayList();
    }

    static HeapWalk instance = new HeapWalk();

    public static void Main() 
    { 
        instance.list.Add(new Foo(10));
        Foo[] arr = new Foo[2];
        arr[0] = new Foo(1);
        arr[1] = new Foo(2);
        HeapInfo heap = new HeapInfo();
        heap.AddRootClass(typeof(HeapWalk));
        heap.AddRoot(arr);
        heap.Refresh();
        foreach (Relation r in heap.Relations(new AnySelector(), new InstanceofSelector(typeof(Foo)))) 
        {
            Console.WriteLine(r.Src + "->" + r.Dst + ": " + r.Count + " links");
        }
        foreach (Instance i in heap.Instances(new AnySelector())) 
        { 
            Console.WriteLine("Class " + i.Class + ": " + i.Count + " instances, " + i.TotalLength + " total length");
        }
    }
}