namespace Heap
{
    using System;
    using System.Collections;
    
    /// <summary> Class representing relation between two classes
    /// </summary>
    public class Relation : IComparable
    {
        /// <summary>
        /// Class of referenced objects
        /// </summary>
        public readonly Type Dst;

        /// <summary>
        /// Class of object containing the reference
        /// </summary>
        public readonly Type Src;
        
        /// <summary>
        /// Number of links between instances of these classes
        /// </summary>
        public int Count;
        
        public  override bool Equals(Object obj)
        {
            if (obj is Relation)
            {
                Relation rel = (Relation) obj;
                return Dst == rel.Dst && Src == rel.Src;
            }
            return false;
        }
        
        public int CompareTo(object o) 
        {
            return ((Relation)o).Count - Count;
        }

        public override int GetHashCode()
        {
            return Src.GetHashCode() ^ Dst.GetHashCode();
        }
        
        internal Relation(System.Type src, System.Type dst)
        {
            Dst = dst;
            Src = src;
        }
    }
}