import java.util.*;
import org.garret.heap.*;

class Foo 
{ 
    private Foo foo;

    Foo(int level) 
    { 
        if (--level >= 0) 
        { 
            foo = new Foo(level);
        }
    }
}

public class HeapWalk 
{
    ArrayList list;

    HeapWalk()  
    { 
        list = new ArrayList();
    }

    static private HeapWalk instance = new HeapWalk();

    public static void main(String[] args) 
    { 
        instance.list.add(new Foo(10));
        Foo[] arr = new Foo[2];
        arr[0] = new Foo(1);
        arr[1] = new Foo(2);
        HeapInfo heap = new HeapInfo();
        heap.addRootClass(HeapWalk.class);
        heap.addRoot(arr);
        heap.refresh();
        Relation[] relations = heap.relations(new AnySelector(), new InstanceofSelector(Foo.class));
        for (int i = 0; i < relations.length; i++) { 
            Relation r = relations[i];
            System.out.println(r.src + "->" + r.dst + ": " + r.count + " links");
        }
        Instance[] insns = heap.instances(new AnySelector());
        for (int i = 0; i < insns.length; i++) {
            Instance insn = insns[i];
            System.out.println("Class " + insn.type + ": " + insn.count + " instances, " + insn.totalLength + " total length");
        }
    }
}